module JKpc(J,K,PR,CL,CLK,Q);
output Q;  
input J;       
input K; 
input CLK;
input PR;
input CL;
                
reg  Q;

always @(posedge CLK or posedge PR or posedge CL) 
  begin   
    if (CL) Q <= 1'b0; 
    else 
    if (PR) Q <= 1'b1;
    else
    	begin
    	Q <= J & ~Q | ~K & Q;
      	end
  end
endmodule
