// top modul
module 
varrogep_minta(RESET,CLK,Q,ld_cntr,up_cntr,cnt_data,komp6,komp12L,komp13);

input RESET;
input CLK;
output [3:0] Q;
output ld_cntr;
output up_cntr;
output [3:0] cnt_data;
output komp12L;
output komp13;
output komp6;


wire RESET;
wire CLK;
wire [3:0] Q;
wire komp6;
wire komp12;
wire komp12L;
wire komp13;
wire up_cntr;
wire ld_cntr;
wire [3:0] cnt_data;

or2 sel_ (komp6,RESET,sel); 								// ld_cntr vezerelese

and2 komp6_ (Q[3],Q[2],komp6); 							// 6 dekodolasa
and4 komp12L_ (~Q[3],~Q[2],~Q[1],~Q[0],komp12); 						// 12 dekodolasa
//and2 komp12L_ (komp12,~up_cntr,komp12L); 						// 12 dekodolasa le szamlalaskor
and4 komp13_ (Q[3],Q[1],~Q[0],up_cntr,komp13); 							// 13 dekodolasa
JKpc up_cntr_ (komp12L,komp13,RESET,1'b0,CLK,up_cntr);			// szamlalasi irany vezerles		
or3 ld_cntr_ (komp12L,komp6,RESET,ld_cntr);						// betoltes vezerles
load3_9 cnt_data_ (sel,cnt_data); 								// betoltendo adat
counter_ud16 counter (cnt_data,ld_cntr,1'b1,up_cntr,CLK,,Q);	// fel le szamlalo

endmodule
