// szinkron toltheto, engedelyezheto fel-le szamlalo
module counter_ud16(DATA,LD,E,DIR,CLK,Mm,Q);
output [3:0] Q; 
output Mm;
input [3:0] DATA;
input LD;    
input E;       
input DIR; 
input CLK;   
                
reg [3:0] Q;

wire CY;
wire BO;

parameter UP=1;
parameter DOWN=0;

assign CY = (Q == 4'hf);
assign BO = (Q == 4'h0);
assign Mm = (DIR == UP) & CY | (DIR == DOWN) & BO;

always @(posedge CLK) 
  begin   
    if (LD) Q <= DATA; 
    else begin
      if (E) 
		begin  
        if (DIR) //DIR=1: count up                 
          if (CY) Q <= 4'h0; 
          else Q <= Q + 1;
        else     //DIR=0: count down 
		  if (BO) Q <= 4'hf;
          else Q <= Q - 1;
      	end
    end
  end 

endmodule
