// top modul
// a cnt_data, LD_masodik, LD_elso, K_vez jelek csak az idodiagrammos 
// megjelenites miatt vannak kivezetve
module varrogep_minta(RESET,CLK,Q,ld_cntr,up_cntr,cnt_data,LD_masodik,LD_elso,K_vez,J_vez);
input RESET;
input CLK;
output [3:0] Q;
output ld_cntr;
output up_cntr;
output [3:0] cnt_data;
output LD_elso;
output K_vez;
output J_vez;
output LD_masodik;
wire RESET;
wire CLK;
wire [3:0] Q;
wire LD_masodik;
wire J_vez;
wire LD_elso;
wire K_vez;
wire up_cntr;
wire ld_cntr;
wire [3:0] cnt_data;

// ld_cntr vezerelese, or2(in1,in2,out)
or2 sel_ (LD_masodik,RESET,sel);
 			
// 6 dekodolasa, and3(in1,in2,in3,out)
and3 LD_masodik_ (~Q[3],Q[2],Q[1], LD_masodik);

// 12 dekodolasa, and3(in1,in2,in3,out)	
and3 J_vez_ (Q[3],~Q[1],~Q[0],J_vez);

// 12 dekodolasa le szamlalaskor, and2(in1,in2,out)	
and2 LD_elso_ (J_vez,~up_cntr,LD_elso);

// 13 dekodolasa, and3(in1,in2,in3,out)	
and3 K_vez_ (Q[3],Q[2],Q[0],K_vez);

// szaml.irany vezerles, JKpc(J, K, Pr, Cl, CLK, Q)	
JKpc up_cntr_ (J_vez,K_vez,RESET,1'b0,CLK,up_cntr);

// betoltes vezerles, or3(in1,in2,in3,out)
or3 ld_cntr_ (LD_elso,LD_masodik,RESET,ld_cntr);

// betoltendo adat
sel_konstans sel_konstans_(sel,cnt_data);

// fel le szamlalo, counter_ud16(DATA, LD, E, DIR, CLK, Mm, Q)		
counter_ud16 counter (cnt_data,ld_cntr,1'b1,up_cntr,CLK,,Q); 
endmodule