module counter_tb();
 	// Bementeket reg-nek kimeneteket wire-nek kell deklaralni
 	reg clk, res;
 	wire [3:0] COUNTER;
 	wire [3:0] CNT_DATA;
 	wire LD;
 	wire DIR;
 	wire LD_masodik;
 	wire LD_elso;
 	wire K_vez;
 	wire J_vez;
 	
 	//parameter ZERO = 4'b0;
 	//parameter H = 1'b1;
 	//parameter L = 1'b0;
 	// Valtozok kezdoereteke
 	initial
	begin
 		$vw_dumpfile("hf2counter.vwf"); // a wave (idodoagram) file neve
 	    $vw_dumpvars(1,clk,res,LD_masodik,LD_elso,K_vez,J_vez,DIR,LD,COUNTER,CNT_DATA);
 	    $vw_group("cnt.wgp",clk,res,LD_masodik,LD_elso,K_vez,J_vez,DIR,LD,COUNTER,CNT_DATA);
 	  	clk = 1; 	// a clock kezdeti erteke
 	  	res = 0; 	// a reset kezdeti erteke
 	  	#5 res = 1; 	// reset kezdete
 	  	#10 res = 0; 	// reset vege
 	  	 
 	  	#200 
 	  	$dumpoff;
		$finish; 	// szimulacio vege
 	end
 	// Clock generator
 	always begin
 	  	#5 clk = ~clk; 	// oreajel periodusido 2x5 egyseg
 	end
 	
// A tesztelendo modul osszekapcsolasa a tesztelovel
// a bemenetek es kimenetek felsorolasat azonos sorendben kell!

 	varrogep_minta device (res,clk,COUNTER,LD,DIR,CNT_DATA,LD_masodik,LD_elso,K_vez,J_vez);
	
 	endmodule